#include"iostream"
#include"mvector.h"
using namespace std;

//Oberklasse fuer alle Objekte im Aquarium
class TankObject{
public:
  TankObject();
  TankObject(mvector x); //jedes Objekt braucht zumindest eine Position im Aquarium
  TankObject(double x,double y, double z);
  mvector position(){return pos;};
  double xposition(){return pos[0];};
  double yposition(){return pos[1];};
  double zposition(){return pos[2];};
protected:
  mvector pos;
};

TankObject::TankObject():pos(){};

TankObject::TankObject(mvector x):pos(x){};

TankObject::TankObject(double x,double y, double z):pos(x,y,z){};


//Oberklasse fuer alle beweglichen Objekte im Aquarium
//Diese Objekte muessen noch zusaetzlich ihre aktuelle Geschwindigkeit kennen und ihre rel "Groesse", die sich im "Sicherheitsabstand" sec vor Hindernissen ausdrueckt
//grosse Objekte und Objekte die sich schnell bewegen koennen brauchen einen groesseren "Sicherheitsabstand" 
class MovedTankObject : public TankObject{
public:
  MovedTankObject();
  MovedTankObject(double s);
  MovedTankObject(mvector x, mvector v,double s);
  MovedTankObject(double x,double y, double z,double v1,double v2,double v3,double s);
  void newpos (mvector x){pos=x;};
  mvector velocity(){return vel;};
  void newvel (mvector v){vel=v;};
  double secdis(){return sec;};
private:
  mvector vel;
  double sec; //"Sicherheitsabstand" vor Hindernissen 
};

MovedTankObject::MovedTankObject():TankObject(),vel(){};

MovedTankObject::MovedTankObject(double s):TankObject(),vel(){sec=s;};

MovedTankObject::MovedTankObject(mvector x, mvector v,double s):TankObject(x),vel(v){sec=s;};

MovedTankObject::MovedTankObject(double x,double y, double z,double v1,double v2,double v3,double s):TankObject(x,y,z),vel(v1,v2,v3){sec =s;};

