#include <math.h>
#include <GL/glut.h> 

#include "myanimation.h"


using namespace std;

int trig=20; //nach dieser Zeit (in Milisekunden) wird ein neues Frame dargestellt
int stop_flag = 0;

void timer(int);

void reshape (int w, int h){
   glViewport (0, 0, (GLsizei) w, (GLsizei) h);
   glMatrixMode(GL_PROJECTION);
   glLoadIdentity();
   gluPerspective(60.0,(float)w/h, 1.0 , 50.0);
}

myanimation an("position.txt", "obstaclea.txt", "obstacleb.txt");

void keyboard(unsigned char key, int x, int y) { 
  switch (key){
  case 'q':  //mit 'q' wird die Animation beendet
    exit(0);
    break;
  case 's':  //mit 's' kann man die Animation anhalten und wieder weiterlaufen lassen
   if (stop_flag ==0){
     stop_flag =1;
   }
   else{
     stop_flag=0;
     glutTimerFunc(trig,timer,0);
   }
   break;
  case 'f':  //mit 'f' kann man die Fische vergroessern und wieder verkleinern
    an.fishsize();
    break;
  }
}



void display(){
  an.mydisplay(); //setzt die Displayfunc auf die Displayfunktion der Animationsklasse
};


void timer(int i){  
  //diese Funktion ruft die methode inc_frame(naechstes Bild bitte) auf und anschliessend ruft sie sich in trig ms selber wieder auf
 
  an.inc_frame();

  if(stop_flag == 0) {
    glutTimerFunc(trig,timer,0);
  }
  glutPostRedisplay();
}


int main(int argc, char** argv){
  
  glutInit(&argc,argv);
 
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGBA | GLUT_DEPTH);
  gluPerspective(60.0, 1.5, 1.0, 50.0);
  glutInitWindowSize(1050,700);  //Fenstergroesse (kann man auch mit der Maus aendern)
  glutInitWindowPosition(100,100);
  glutCreateWindow("Aquarium /press q to quit / f for big or small fishes / s to stop or start  ");
  
  glClearColor(0.0,0.0,0.0,0.0);
  glClearDepth(1.0);
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
  gluLookAt(12,12,25,  //Position der Kamera und Blickrichtung
	    10,7.5,0.0,
	    0.0,1.0,0.0);

  glEnable(GL_DEPTH_TEST);

  glEnable(GL_NORMALIZE);
  
  glEnable(GL_COLOR_MATERIAL);
  glShadeModel(GL_SMOOTH);
 
  glEnable(GL_LIGHTING);
  glEnable(GL_LIGHT0);

  GLfloat pos[]={10.0,12.0,21.0,0};
  glLightfv(GL_LIGHT0, GL_POSITION, pos);

  GLfloat li[]={1.0,1.0,1.0,1.0};
  GLfloat amb[]={0.2,0.2,0.2,1.0};
  glLightfv(GL_LIGHT0, GL_DIFFUSE, li);
  glLightfv(GL_LIGHT0, GL_SPECULAR, li);
  glLightfv(GL_LIGHT0, GL_AMBIENT, amb);

  GLfloat dif[]={0.78,0.57,0.11,1.0};
  GLfloat spec[]={0.99,0.91,0.81,1.0};
  amb[0]=0.33; amb[1]=0.22; amb[2]=0.03;
 
  glMaterialfv(GL_FRONT, GL_DIFFUSE, dif);
  glMaterialfv(GL_FRONT, GL_SPECULAR, spec);
  glMaterialfv(GL_FRONT, GL_AMBIENT, amb);
  glMaterialf(GL_FRONT, GL_SHININESS, 28);
  
  glutReshapeFunc(reshape);
  glutDisplayFunc(display);
  glutKeyboardFunc(keyboard);

 
  glutTimerFunc(trig,timer,0);

  glutMainLoop();


  return 0;

}

