#include"vector"

using namespace std;

//drei dimensionaler Vektor, mit den in einem OrthoNormalSystem ueblichen Operationen
class mvector{
public:
  mvector ();
  mvector (const mvector& n); //Copyconstruktor
  mvector (double x1,double x2, double x3);
  mvector& operator= (const mvector& n); //Zuweisungsoperator
  mvector operator+ (const mvector& n); //Additionsoperator
  double& operator[] (int n); //indizierter Zugriff auf die drei Elemente des Vektors
  mvector operator- (const mvector& n); //Subtraktionsoperator
  double betrag(); //liefert die "Laenge" des Vektors
  mvector operator* (double n); //Multiplikation mit einem Skalar
  double operator* (const mvector& n);  //Skalarprodukt
  void norm(); //normiert den Vektor
  mvector kreuz (const mvector& n); //Vektorprodukt (Kreuzprodukt)
  bool operator== (const mvector& n); //Vergleichsoperator
 private:
  vector<double> val;

};

mvector::mvector():val(3,0){ };

mvector::mvector(const mvector& n){
  val=n.val;};

mvector::mvector(double x1, double x2, double x3):val(3,0){
  val[0]=x1; val[1]=x2; val[2]=x3;};

mvector& mvector::operator=(const mvector& n){
  val=n.val;
  return *this;};

mvector mvector::operator+(const mvector& n){
 mvector a;
 a.val[0]=val[0]+n.val[0];
 a.val[1]=val[1]+n.val[1];
 a.val[2]=val[2]+n.val[2];
 return a;};

double& mvector::operator[] (int n) {
  if ((n>=0) && (n<3)) {
    return val[n];
  }
  else {
    cerr<<"Falscher Index"<<endl;
  }
};

mvector mvector::operator-(const mvector& n){
 mvector a;
 a.val[0]=val[0]-n.val[0];
 a.val[1]=val[1]-n.val[1];
 a.val[2]=val[2]-n.val[2];
 return a;};

double mvector::betrag(){
  return(sqrt(val[0]*val[0]+val[1]*val[1]+val[2]*val[2]));};

mvector mvector::operator*(double n){
 mvector a;
 a.val[0]=val[0]*n;
 a.val[1]=val[1]*n;
 a.val[2]=val[2]*n;
 return a;};

double mvector::operator*(const mvector& n) {
  return(val[0]*n.val[0]+val[1]*n.val[1]+val[2]*n.val[2]);};

void mvector::norm(){
  double i=betrag();
  val[0]=(1/i)*val[0];
  val[1]=(1/i)*val[1];
  val[2]=(1/i)*val[2];
};

mvector mvector::kreuz(const mvector& n){
  mvector a;
  a.val[0]=(val[1]*n.val[2] - n.val[1]*val[2]);
  a.val[1]=(val[2]*n.val[0] - n.val[2]*val[0]);
  a.val[2]=(val[0]*n.val[1] - n.val[0]*val[1]);
  return a;
};

bool mvector::operator==(const mvector& n){
  if(((val[0]==n.val[0])&&(val[1]==n.val[1]))&&(val[2]==n.val[2]))return true;
  else return false;
};
