#include "fstream"
#include "list"
#include "objects.h"

using namespace std;

class myanimation {
public:
  myanimation (char inputfile[20], char obstaca[20], char obstacb[20]);
  void mydisplay(); //displayfunc
  void inc_frame(); //methode setzt den Pointer auf das naechste Frame, das dargestellt weden soll
  void fishsize(); //der Aufruf dieser Methode aendert die groesse der Fische

private:
  void drawwand (); //zeichnet die Aquariumswaende
  void drawfisch(mvector &x, mvector &v); //zeichnet die Fische
  void drawobstaclea(); //zeichnet Hindernisse der Art a(Kugel)
  void drawobstacleb(); //   --||--     --||--         b(Zylinder)
  mvector ortho(mvector v); 
  int SCALEFAC; //Skalenfaktor fuer die groesse der Fische
  int fnumber;  //Anzahl der Fische
  int length,height,depth; //Groesse des Aquariums
  struct frame{  //diese Frames enthalten die Positionen und Geschwindigkeiten der Fische
    mvector array[60][2]; //jedes Frame stellt ein Einzelbild dar
  };
  list<frame> framelist; //Liste fuer die Frames(Filmrolle)
  list<frame>::iterator it; //Zeiger auf die Einzelbilder, bestimmt welches bild gerade gezeigt wird
  vector<obstaclea>  oa; //Kontainer fuer Hindernisse a
  vector<obstacleb>  ob; //   --||--                  b
};

myanimation:: myanimation (char inputfile[20], char obstaca[20], char obstacb[20]){ 
  //Konstruktor hat die Namen der Inputfiles als Argument 
  SCALEFAC=1;
  ifstream in,in1,in2;
  mvector x,v;
 
  in.open(inputfile, ios::in);
  if (!in){
    cerr<<endl<<"Eingabedatei konnte nicht geffnet werden!"<<endl;}
  
  char s[15];
  
  in.getline(s,14);
  length=atoi(s);
  in.getline(s,14);
  height=atoi(s);             //Groesse des Aquariums wird eingelesen
  in.getline(s,14);           //steht am Anfang des Files mit den Fischpositionen
  depth=atoi(s);
  in.getline(s,14);
  fnumber=atoi(s);
 
  struct frame f;
  
  while(!in.eof()){
    for (int ii=0;ii<fnumber;ii++){
      in.getline(s,14);
      x[0]=atof(s);
      in.getline(s,14);
      x[1]=atof(s);
      in.getline(s,14);
      x[2]=atof(s);
      in.getline(s,14);
      v[0]=atof(s);
      in.getline(s,14);        //Position und Geschwindigkeit der Fische wird 
      v[1]=atof(s);            //in den Frames und in der Liste eingelesen
      in.getline(s,14);
      v[2]=atof(s);
      f.array[ii][0]=x;
      f.array[ii][1]=v;
    }
 
    framelist.push_back(f);
      
  }
 
  in.close();
  double r,h;
  it=framelist.begin();

  in1.open(obstaca, ios::in);
  if (!in1){
    cerr<<endl<<"Eingabedatei konnte nicht geffnet werden!"<<endl;}
  
  while(!in1.eof()){
    in1.getline(s,14);
    x[0]=atof(s);
    in1.getline(s,14);
    x[1]=atof(s);
    in1.getline(s,14);   //Hindernisse werden eingelesen
    x[2]=atof(s);
    in1.getline(s,14);
    r=atof(s);
    obstaclea oba(x,r);
    oa.push_back(oba);    
  }
  in1.close();
  
  in2.open(obstacb, ios::in);
  if (!in2){
    cerr<<endl<<"Eingabedatei konnte nicht geffnet werden!"<<endl;}
  
  while(!in2.eof()){
    in2.getline(s,14);
    x[0]=atof(s);
    in2.getline(s,14);
    x[1]=atof(s);
    in2.getline(s,14);  //Hindernisse werden eingelesen
    x[2]=atof(s);
    in2.getline(s,14);
    h=atof(s);
    in2.getline(s,14);
    r=atof(s);
    if(r!=0){obstacleb obb(x,h,r);
    ob.push_back(obb);}    
 }
  in2.close();
};

void myanimation::mydisplay(){
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
  
  
  glMatrixMode(GL_MODELVIEW);
  
  drawwand();

  if (oa.size() != 0) drawobstaclea();
  if (ob.size() != 0) drawobstacleb();

  for (int ii=0; ii<fnumber; ii++) {
    //jeder Fisch aus dem Frame wird gezeichnet it gibt den Frame an
    drawfisch(it->array[ii][0],it->array[ii][1]);
  }

  glutSwapBuffers(); 

};


void myanimation::inc_frame(){
  //diese Methode dreht die Filmrolle jeweils um ein Einzelbild weiter
  if (it!=framelist.end()){
    it++;
    if (it==framelist.end()){
      it=framelist.begin(); //und wieder von vorne
    } 
  }

};


void myanimation::drawwand(){
  //diese Methode zeichnet die einzelnen Aquariumswaende
 
  //Boden:
  glColor3f(0.7,0.7,0.0);
  glBegin(GL_QUADS);
  glNormal3f(0.0,1.0,0.0);
  glVertex3f(0.0,0.0,0.0);
  glVertex3f(length,0.0,0.0);
  glVertex3f(length,0.0,depth);  
  glVertex3f(0.0,0.0,depth);
 
  //hintere Wand:
  glColor3f(0.7,0.7,0.0);
  glNormal3f(0.0,0.0,1.0);
  glVertex3f(0.0,0.0,0.0);
  glVertex3f(length,0.0,0.0);
  glVertex3f(length,height,0.0);
  glVertex3f(0.0,height,0.0);

  //linke Seitenwand:
  glColor3f(0.7,0.7,0.0);
  glNormal3f(1.0,0.0,0.0);
  glVertex3f(0.0,0.0,0.0);
  glVertex3f(0,height,0.0);
  glVertex3f(0.0,height,depth);
  glVertex3f(0.0,0.0,depth);
	    
  //rechte Seitenwand:
  glColor3f(0.7,0.7,0.0);
  glNormal3f(-1.0,0.0,0.0);
  glVertex3f(length,0.0,0.0);
  glVertex3f(length,height,0.0);
  glVertex3f(length,height,depth);
  glVertex3f(length,0.0,depth);
  glEnd();
};

void myanimation::drawfisch(mvector &x, mvector &v){  
  //jeder Fisch wird als ein langgezogenes(in Richtung der Geschwindigkeit Tetraeder dargestellt
  //die Vektoren p1 bis p4 stellen die Eckpunkte des Tetraeders dar
  //p1 stellt die Spitze des Fisches dar(in Richtung des Gescwindigkeitsvektors)
  // Die Fische haben eine flache Unterseite und p2 stellt die Orientierung dar(so etwas wie die Reckenflosse beim Hai)
  //Orientierung: Der Verbindungsvektor nv Unterseite->p2 steht immer orthogonal zur Geschwindigkeit und hat einen Ateil >= 0 in die positive y-Richtung(oben) (genaueres siehe Methode ortho)

  glColor3f(0.0,0.0,1.0);
  mvector nv=ortho(v);
  nv.norm();
  v.norm();
  mvector p1=x+v*0.05*SCALEFAC;
  mvector p2=(x-v*0.03*SCALEFAC)+nv*0.05*SCALEFAC;
  nv=nv.kreuz(v);
  nv.norm();
  mvector p3=(x-v*0.03*SCALEFAC)+nv*(0.04)*SCALEFAC;
  mvector p4=(x-v*0.03*SCALEFAC)+nv*(-0.04)*SCALEFAC;

  mvector n1,n2,n3,n4,h1,h2;
  h1=p2-p1;
  h2=p3-p1;
  n1=h2.kreuz(h1);

  h2=p4-p1;
  n2=h1.kreuz(h2);

  n3=nv.kreuz(v);

  n4=v*(-1);

  glBegin(GL_TRIANGLES);
    glNormal3f(n1[0],n1[1],n1[2]); 
    glVertex3f(p1[0],p1[1],p1[2]);
    glVertex3f(p2[0],p2[1],p2[2]);
    glVertex3f(p3[0],p3[1],p3[2]);
 
    glNormal3f(n2[0],n2[1],n2[2]); 
    glVertex3f(p1[0],p1[1],p1[2]);
    glVertex3f(p2[0],p2[1],p2[2]);
    glVertex3f(p4[0],p4[1],p4[2]);

    glNormal3f(n3[0],n3[1],n3[2]); 
    glVertex3f(p1[0],p1[1],p1[2]);
    glVertex3f(p3[0],p3[1],p3[2]);
    glVertex3f(p4[0],p4[1],p4[2]);

    glNormal3f(n4[0],n4[1],n4[2]); 
    glVertex3f(p2[0],p2[1],p2[2]);
    glVertex3f(p3[0],p3[1],p3[2]);
    glVertex3f(p4[0],p4[1],p4[2]);
  glEnd();

 };

void myanimation::drawobstaclea(){
  for (vector<obstaclea>::iterator kk=oa.begin();kk!=oa.end();kk++){
    glPushMatrix();
    glTranslatef(kk->xposition(),kk->yposition(),kk->zposition());
    glColor3f(0.8,0.0,0.0); 
    glutSolidSphere(kk->radius(),30,30);
    glPopMatrix();
  }
};

void myanimation::drawobstacleb(){
  for (vector<obstacleb>::iterator kk=ob.begin();kk!=ob.end();kk++){
    
    double r=kk->radius();
    double h=kk->height();
    
    glPushMatrix();
    glTranslatef(kk->xposition(),kk->yposition(),kk->zposition());
    glColor3f(0.0,0.7,0.0); 
    glBegin(GL_QUAD_STRIP);
    for (float ii=-r; ii<=r; ii=ii+0.1){
      glNormal3f(ii, 0.0, sqrt(r*r-(ii*ii)));
      glVertex3f(ii, 0.0, sqrt(r*r-(ii*ii)));
      glNormal3f(ii, 0.0, sqrt(r*r-(ii*ii)));
      glVertex3f(ii, h, sqrt(r*r-(ii*ii)));
    }
    glNormal3f(1.0, 0.0, 0.0);
    glVertex3f(r, 0.0, 0.0);
    glNormal3f(1.0, 0.0, 0.0);
    glVertex3f(r, h, 0.0);
    glEnd();
    
    glBegin(GL_QUAD_STRIP);
    for (float ii=-r; ii<r; ii=ii+0.1){
      glNormal3f(ii, 0.0, -sqrt(r*r-(ii*ii)));
      glVertex3f(ii, 0.0, -sqrt(r*r-(ii*ii)));
      glNormal3f(ii, 0.0, -sqrt(r*r-(ii*ii)));
      glVertex3f(ii, h, -sqrt(r*r-(ii*ii)));
    }
    glNormal3f(1.0, 0.0, 0.0);
    glVertex3f(r, 0.0, 0.0);
    glNormal3f(1.0, 0.0, 0.0);
    glVertex3f(r, h, 0.0);
    glEnd();
    
    glColor3f(0.0,0.6,0.0);
    glBegin(GL_TRIANGLE_FAN);
    glNormal3f(0.0, 1.0, 0.0);
    glVertex3f(0.0,0.0,0.0);
    for (float ii=-r;ii<=r;ii=ii+0.1){
      glNormal3f(0.0,1.0,0.0);
      glVertex3f(ii, h, sqrt(r*r-(ii*ii)));
    }
    glEnd();
    
    glBegin(GL_TRIANGLE_FAN);
    glNormal3f(0.0,1.0,0.0);
    glVertex3f(0.0,h,0.0);
    for (float ii=-r; ii<=r; ii=ii+0.1){
      glNormal3f(0.0, 1.0, 0.0);
      glVertex3f(ii, h,-sqrt(r*r-(ii*ii)));
    }
    glEnd();
    
    glPopMatrix();
  }
};


mvector myanimation::ortho(mvector v){
  //da hier beide Vektoren normiert werden liefert diese Methode ein Vektor, der senkrecht auf v steht und ein Anteil >= 0 in die positive y-Richtung(oben) hat(falls n und v linear unabhaengig)
  mvector n(0,1,0);
  v.norm();
  n=n-v*(n*v);
  if(((n[0]==0)&&(n[1]==0))&&(n[2]==0)){
    n[2]=1;
  }
  return n;
};

void myanimation::fishsize(){
  if (SCALEFAC==1){
    SCALEFAC=2;
  }
  else{
    SCALEFAC=1;
  }
};
