#include"TankObjects.h"

//diese Klasse ist keine allgemeine Klasse fuer Fische sondern stellt im grunde eine ganz konkrete Art von Fisch dar (z.Bsp.: Forelle), denn durch mindis, MAXV und MAXAC sind bereits ung. die Groesse, Maximalgeschwindigkeit und Beweglichkeit festgelegt
class fisch : public MovedTankObject{
 public:
  fisch ();
  fisch(mvector x, mvector v);
  fisch(double x,double y, double z,double v1,double v2,double v3);
  double DIS; //Abstand zu dem "aktuellen" (gerade simulierten) Fisch
  double mindis(){return MINDIS;}; 
  double optdis(){return OPTDIS;};
  double maxv(){return MAXV;};
  double maxac(){return MAXAC;}; 
 private:
  double MINDIS; //Mindestabstand zum naechsten Fisch
  double OPTDIS; //zwischen MINDIS und OPTDIS befindet sich der Abstand, den die Fische am "liebsten" zueinander haben
  double MAXV; //Maximalgeschwindigkeit
  double MAXAC; //Maximalbeschleunigung (Beweglichkeit)
};

fisch::fisch():MovedTankObject(1.0){
  DIS=0;
  MINDIS=0.45;
  OPTDIS=0.9;
  MAXAC=60.0;
  MAXV=5.0; 
};

fisch::fisch(mvector x, mvector v):MovedTankObject(x,v,1.0){
  DIS=0;
  MINDIS=0.35;
  OPTDIS=0.7;
  MAXAC=60.0;
  MAXV=5.0;  
};

fisch::fisch(double x,double y, double z,double v1,double v2,double v3):MovedTankObject(x,y,z,v1,v2,v3,1.0){
  DIS=0;
  MINDIS=0.35;
  OPTDIS=0.7;
  MAXAC=60.0;
  MAXV=5.0; 
};


//Hindernis a: Kugel
class obstaclea : public TankObject{
 public:
  obstaclea ();
  obstaclea (double x, double y, double z, double r);
  obstaclea (mvector x,double r);
  double radius(){return RADIUS;};
  double D;
 private:
  double RADIUS;
};

obstaclea::obstaclea():TankObject(){RADIUS=0.0;};

obstaclea::obstaclea(double x, double y, double z, double r):TankObject(x,y,z){RADIUS=r;};

obstaclea::obstaclea(mvector x, double r):TankObject(x){RADIUS=r;};


//Hindernis b: Zylinder
class obstacleb: public TankObject{
 public:
  obstacleb ();
  obstacleb (double x, double y, double z, double h, double r);
  obstacleb (mvector x,double h,double r);
  double height(){return HEIGHT;};
  double radius(){return RADIUS;};
  double D;
 private:
  double HEIGHT,RADIUS;
};

obstacleb::obstacleb():TankObject(){HEIGHT=0.0;RADIUS=0.0;};
obstacleb::obstacleb(double x, double y, double z, double h,double r):TankObject(x,y,z){HEIGHT=h;RADIUS=r;};
obstacleb::obstacleb(mvector x,double h,double r):TankObject(x){HEIGHT=h;RADIUS=r;};



