#include <iostream>
#include <ios>
#include <vector>
#include <fstream>
#include <time.h>
#include <math.h>

#include "objects.h"

using namespace std;

class simulation{
public:
  simulation (int nr, int r);
  void simstart ();
  ~simulation();

private:
  bool flag1,nf;
  mvector a,b,ac;
  int length,height,depth,n,count; //Groee des Aquariums und  Gesamtzahl der Fische 
  double ACTUAL_MINDIS,repuls,ACTUAL_OPTDIS,atrac,step,repeat,ACTUAL_MAXAC,ACTUAL_MAXV,ACTUAL_SEC;
  mvector ACTUAL_VEL,ACTUAL_POS; //Position und Geschwindigkeit des gerade simulierten (aktuellen) Fisches 
  vector<fisch>  schw; //in diesem Kontainer werden die Fische verwaltet
  mvector w1p,w1m,w2p,w2m,w3p,w3m; //hilfsvektoren
  fisch *f;
  fisch *near[6];   //Feld mit Pointern auf die 6 naechsten Fische des aktuellen Fisches
  fisch** circle;   //Feld mit Pointern auf Fische in einem bestimmten Abstand (Schwarm)
  vector<obstaclea>  oa; //Es gibt vorerst zwei Arten von Hindernissen: a(Kugel) und b(Zylinder)
  vector<obstacleb>  ob; 

  inline void dodge_obstaclea ();
  inline void dodge_obstacleb ();
  inline void dodge_wand();
  inline void fischinteraction();
  inline mvector ortho(mvector v,mvector w);
  double betrag(double x);
  void sort(fisch* n[6]);
  void randomposition();
};

simulation::simulation(int nr,int r):a(),b(),ac(),schw(nr),w1p(1,0,0),w1m(-1,0,0),w2p(0,1,0),w2m(0,-1,0),w3p(0,0,1),w3m(0,0,-1) {
  circle=new fisch*[nr];
  flag1=0;
  length=20;  //Aquariumsbreite
  height=18;  //Aquariumshohe
  depth=12;   //Aquarimstiefe
  repeat=r;   //Anzahl der Simulationsschritte
  count=0;
  n=nr; 
  repuls=100.0; //Konstante fr die Staerke der Abstossung
  atrac=30.0;   // --||--           --||--      Anziehung
  step=0.002;   //Konstante, die angibt, wie genau die Simulation ist (Zeitschritte in Sek.)

  srand( (unsigned) time(NULL)); //Kopplung des Zufallsgenerators an die Zeit
};

simulation::~simulation(){
  delete[](circle);
};

mvector simulation::ortho(mvector v,mvector w){
  w.norm();      
  v.norm();
  w=w-v*(w*v);    //Diese Methode gibt den Senkrechten Anteil von w auf v zurueck
  return w;
};

double simulation::betrag(double x){
  if(x<0)return(-x);
  else return x;
};

void simulation::sort(fisch* n[6]){  //Diese Funktion sortiert die Pointern auf die 6 naechsten Fische
  fisch *a;
  for (int jj=6-1;jj>=0;jj--){     //nach den Abstand zum aktuellen Fisch
    for (int ii=0;ii<jj;ii++){
      if(n[ii+1]->DIS < n[ii]->DIS){
	a=n[ii];
	n[ii]=n[ii+1];
	n[ii+1]=a;
      }
    }
  }
};

void simulation::dodge_wand(){  //diese Funktion sorgt dafuer, dass die Fische im Aquarium bleiben
  if (ACTUAL_POS[0] <= (ACTUAL_MINDIS+ACTUAL_SEC)){ 
    ac=ac+w1p*(repuls*1/(ACTUAL_POS[0]*ACTUAL_POS[0]*ACTUAL_POS[0]*ACTUAL_POS[0]));
  }
 
  if ((length-ACTUAL_POS[0]) <= (ACTUAL_MINDIS+ACTUAL_SEC)){
    ac=ac+w1m*(repuls*1/((length-ACTUAL_POS[0])*(length-ACTUAL_POS[0])*(length-ACTUAL_POS[0])*(length-ACTUAL_POS[0])));
  }
  
  if (ACTUAL_POS[1] <= (ACTUAL_MINDIS+ACTUAL_SEC)){
    ac=ac+w2p*(repuls*1/(ACTUAL_POS[1]*ACTUAL_POS[1]*ACTUAL_POS[1]*ACTUAL_POS[1]));
  }
  
  if ((height-ACTUAL_POS[1]) <= (ACTUAL_MINDIS+ACTUAL_SEC)){
    ac=ac+w2m*(repuls*1/((height-ACTUAL_POS[1])*(height-ACTUAL_POS[1])*(height-ACTUAL_POS[1])*(height-ACTUAL_POS[1])));
  }
  
  if (ACTUAL_POS[2] <= (ACTUAL_MINDIS+ACTUAL_SEC)){
    ac=ac+w3p*(repuls*1/(ACTUAL_POS[2]*ACTUAL_POS[2]*ACTUAL_POS[2]*ACTUAL_POS[2]));
  }
  
  if ((depth-ACTUAL_POS[2]) <= (ACTUAL_MINDIS+ACTUAL_SEC)){
    ac=ac+w3m*(repuls*1/((depth-ACTUAL_POS[2])*(depth-ACTUAL_POS[2])*(depth-ACTUAL_POS[2])*(depth-ACTUAL_POS[2])));
  }
};

void simulation::fischinteraction(){ 
  for (int ii=0;ii<6;ii++){
    if (near[ii]->DIS <= ACTUAL_MINDIS){  //wenn sich die Fische zu nahe kommen erfahren sie eine abstoende Kraft in Richtung des Verbindungsvektors a
      a=ACTUAL_POS-near[ii]->position();
      a.norm();
      if(near[ii]->DIS==0)cout<<"Singularitaet! Bitte abbrechen und Simulation erneut starten."<<endl;
      ac=ac+a*(repuls*1.0/((near[ii]->DIS)*(near[ii]->DIS)*(near[ii]->DIS)));
    }
   
    if (nf==true) if (near[ii]->DIS > ACTUAL_OPTDIS){
      a=near[ii]->position()-ACTUAL_POS;   //Anziehung bei zu groen Abstand
      a.norm();
      ac=ac+a*(atrac*near[ii]->DIS*50);
    }
  }	
};

void simulation::dodge_obstaclea (){ //Ausweichen eines Kugelfoermigen Hindernisses
  for (vector<obstaclea>::iterator kk=oa.begin();kk!=oa.end();kk++){
    a=kk->position()-ACTUAL_POS; //Verbindungsvektor Position(Fisch)--Mittelpunkt
    if (a.betrag()<(kk->radius()+1.5*ACTUAL_SEC)){ //wird nur ausgefhrt, wenn sich der Fisch in der naehe der Kugel befindet
      b=ACTUAL_VEL;
      b.norm();
      kk->D=sqrt(a.betrag()*a.betrag()-(a*b)*(a*b)); //Abstand Punkt Gerade
      if (kk->D-0.2 <= kk->radius()){
	nf=false;
	if (kk->D == 0){
	  b=kk->position().kreuz(ACTUAL_VEL);
	  if (((b[0]!=0)||(b[1]!=0))||(b[2]!=0)){
	    b.norm();
	    ac=ac+b*3000;
	  }
	  else{
	    a=a*0;
	    a[1]=1;
	    b=ACTUAL_VEL.kreuz(a);
	    ac=ac+b*3000;
	  }
	}
	b=b*(a*b)+ACTUAL_POS; 
	a=b-kk->position();
	a=ortho(ACTUAL_VEL,a);  //Ausweichvektor senkrecht zur Gescwindigkeit und vom Mittelpunkt weg
	a.norm();
	ac=ac+a*3000;
      }
    }
  }
};

void simulation::dodge_obstacleb (){ //Auswichen eines Zylinderfoermigen Hindernisses
  for (vector<obstacleb>::iterator kk=ob.begin();kk!=ob.end();kk++){ 
    if ((sqrt((ACTUAL_POS[0]-kk->position()[0])*(ACTUAL_POS[0]-kk->position()[0])+(ACTUAL_POS[2]-kk->position()[2])*(ACTUAL_POS[2]-kk->position()[2])) < (kk->radius()+1.5*ACTUAL_SEC)) && (ACTUAL_POS[1] <= kk->height()+ACTUAL_SEC*1.5)){
      b=b*0;
      b[1]=1; //b zeigt in Richtung der Achse
      a=ACTUAL_VEL.kreuz(b); //Ausweichvektor a steht senkrecht auf Achse und Geschwindigkeitsvektor
      a.norm();
      kk->D = betrag((ACTUAL_POS-kk->position())*a); //Abstand zweier windschiefen Geraden
      if(kk->radius() > (kk->D-0.2)){
	b=ACTUAL_POS+ACTUAL_VEL*0.01;
	if (((ACTUAL_POS[0]-kk->position()[0])*(ACTUAL_POS[0]-kk->position()[0])+((ACTUAL_POS[2]-kk->position()[2])*(ACTUAL_POS[2]-kk->position()[2])))  >= ((b[0]-kk->position()[0])*(b[0]-kk->position()[0])+((b[2]-kk->position()[2])*(b[2]-kk->position()[2])))){ //hier wurde geschaut, ob der Fisch auf das Hindernis zuschwimmt oder nicht
	  nf=false;
	  if(kk->D==0){
	    if (((a[0]==0)&&(a[1]==0))&&(a[2]==0)){
	      b=b*0;
	      b[2]=1;
	      ac=ac+b*3000;
	    }
	    else {
	      ac=ac+a*3000;
	    }
	  }	  
	  else{
	    b=kk->position()+a*0.01;  //hier wird geachtet, dass das Auweichmanoever auch wirklich von der Achse wegfuehrt
	    if(kk->D < betrag((ACTUAL_POS-b)*a)){
	      ac=ac-a*3000;
	    }
	    else {
	      ac=ac+a*3000;
	    }
	  }
	}
      }
    }
  }
};

void simulation::randomposition(){ 
  //die Fische werden zufaellig im Aquarium platziert, mit zufaelliger Geschwindigkeit
  for (vector<fisch>::iterator i=schw.begin(); i!=schw.end(); i++){
    ACTUAL_POS[0]=(random()%(length-2)+1);ACTUAL_POS[1] =(random()%(height-2)+1);ACTUAL_POS[2]=(random()%(depth-2)+1); ACTUAL_VEL[0]=random()%6; ACTUAL_VEL[1]=random()%6; ACTUAL_VEL[2] =random()%6;
    for (vector<obstaclea>::iterator kk=oa.begin();kk!=oa.end();kk++){
      a=kk->position()-ACTUAL_POS;
      if (a.betrag()<(kk->radius()+1.5*i->secdis())){ //es wird darauf geachtet, dass sie sich nicht zu nahe an den Hindernissen befinden
	flag1=true;
	break;
      }
    }
    if (flag1==false){
      for (vector<obstacleb>::iterator kk=ob.begin();kk!=ob.end();kk++){ 
	if ((sqrt((ACTUAL_POS[0]-kk->position()[0])*(ACTUAL_POS[0] -kk->position()[0])+(ACTUAL_POS[2]-kk->position()[2])*(ACTUAL_POS[2]-kk->position()[2])) < (kk->radius()+1.5*i->secdis())) && (ACTUAL_POS[1] <= kk->height()+i->secdis())){
	  flag1=true;
	  break;
	}
      }
    }
    if(flag1==true){
      i=i-1;
      flag1=false;
    }
    else{
      i->newpos(ACTUAL_POS);
      i->newvel(ACTUAL_VEL);
    }
  }
  //Es kann geschehen, dass zwei Fische auf derselben Position gesetzt werden. Dann gibt es eine Singularitaet und die Simulation muss neu gestartet werden
};

//Start der Simulation
void simulation::simstart(){

  cout<<"Bitte Anzahl der Hindernisse angeben (1,2,3 oder 4): "<<endl;
  int i;
  cin>>i;
  while (((((i==1)||(i==2))||(i==3))||(i==4))==0){
    cout<<"Bitte erneut eingeben:"<<endl;
    cin>>i;
  }
  cout<<"Bitte warten! Simulation luft."<<endl;
  //Positionierung der Hindernisse, je nach Auswahl
  if (i==1){
    obstacleb ob1(10.0,0.0,3.5,5.5,1.0);
    ob.push_back(ob1);
  }
  if (i==2){
    obstacleb ob1(6.0,0.0,6.0,12.0,1.3);
    obstacleb ob2(12.0,0.0,7.0,5.5,1.0);
    ob.push_back(ob2);
    ob.push_back(ob1);
  }
  if (i==3){
    obstacleb ob2(12.0,0.0,6.0,8.5,1.0);
    obstacleb ob1(6.0,0.0,5.0,14.0,1.3);
    obstaclea oa1(15.5,11.5,7.5,2.5);
    oa.push_back(oa1);
    ob.push_back(ob2);
    ob.push_back(ob1);
  }
  if (i==4){
    obstaclea oa3(15.5,11.5,7.5,2.5); 
    obstacleb ob2(4.5,0.0,8.5,14.0,1.3);
    obstacleb ob3(12.5,0.0,6.0,8.5,1.0);
    obstaclea oa2(7.5,5.0,5.0,2.5);
    oa.push_back(oa2);
    oa.push_back(oa3);
    ob.push_back(ob2);
    ob.push_back(ob3);
  }

  ofstream raus;
  raus.open("obstaclea.txt",ios::out); 
  if (!raus) {
    cout<<"Ausgabedatei konnte nicht geffnet werden!"<<endl<<endl;
  }
  raus.setf(ios_base::fixed);
  
  //die Hindernisse werden rausgeschrieben, damit sie nacher in der Animation dargestellt werden koennen
  if (oa.size()!=0){
    for (vector<obstaclea>::iterator kk=oa.begin();kk!=oa.end();kk++){
      raus<<kk->xposition()<<"\n"<<kk->yposition()<<"\n"<<kk->zposition() << 
	"\n"<<kk->radius()<<"\n";
    }
  }
  raus.close();
  
  raus.open("obstacleb.txt",ios::out);
  if (!raus) cout<<"Ausgabedatei konnte nicht geffnet werden!"<<endl;
  
  if (ob.size()!=0){
    for (vector<obstacleb>::iterator kk=ob.begin();kk!=ob.end();kk++){
      raus<<kk->xposition()<<"\n"<<kk->yposition()<<"\n"<<kk->zposition() << 
	"\n"<<kk->height()<<"\n"<<kk->radius()<<"\n";
    }
  } 
  raus.close();
 
  raus.open("position.txt",ios::out); //outputstream fr die Position und Geschwindigkeit(fuer die Orientierung) der Fische
  if (!raus) cout<<"Ausgabedatei konnte nicht geffnet werden!"<<endl<<endl;

  raus<<length<<"\n"<<height<<"\n"<<depth<<"\n"<<n<<"\n"; //am Anfang des Files stehen die Mae des Aquariums

  ACTUAL_MINDIS=schw[0].mindis();  //Mindestabstand zwischen den simulierten Objekten
  ACTUAL_OPTDIS=schw[0].optdis();  //optimaler Abstand
  ACTUAL_MAXAC=schw[0].maxac();    //Maximalbeschleunigung
  ACTUAL_MAXV=schw[0].maxv();      //Maximalgeschwindigkeit

  randomposition();

  for (int jj=0; jj<n; jj++){
    ACTUAL_POS=schw[jj].position();
    ACTUAL_VEL=schw[jj].velocity();
    raus<<ACTUAL_POS[0]<<"\n"<<ACTUAL_POS[1]<<"\n"<<ACTUAL_POS[2]<<"\n"<<ACTUAL_VEL[0]<<"\n"<<ACTUAL_VEL[1]<<"\n"<<ACTUAL_VEL[2]<<"\n";
  }

  for(int aa=0;aa < repeat;aa++){ //Aussere Schleife fr die Simulation
    ACTUAL_SEC=schw[0].secdis();
    for (int jj=0;jj<n;jj++){
      count=0;
      //die Methoden der Simulation arbeiten immer mit ACTUAL_POS, ACTUAL_VEL, ACTUAL_... unabhaengig von der genauen Art des simulierten Objekts(Fisch oder Taucher z.Bsp.)
      ACTUAL_POS=schw[jj].position();
       ACTUAL_VEL=schw[jj].velocity();
      for (int ii=0;ii<n;ii++){
	if(ii!=jj){
	  a=schw[ii].position()-ACTUAL_POS;
	  schw[ii].DIS=a.betrag(); //Abstand zum aktuellen Fisch
	  if (schw[ii].DIS <= 1.2) { //hier werden alle Fische rausgesucht, die sich im Umkreis von 1.2 befinden
	    circle[count]=&schw[ii];
	    count++;}
	}
      }
     
      // * nun werden die 6 Fische rausgesucht, die sich dem simulierten Fisch am naechsten befinden
      if (jj>=6){for (int ii=0;ii<6;ii++){
	near[ii]=&schw[ii];};
      }
      else {for (int ii=0;ii<=6;ii++){
	if (ii<jj) near[ii]=&schw[ii];
	else if (ii>jj) near[ii-1]=&schw[ii];}
      };
      sort(near);
      
      for (int ii=6;ii<n;ii++){
	if (ii!=jj) {for (int kk=0;kk<6;kk++){
	  if (schw[ii].DIS < near[kk]->DIS){
	    if(kk!=6-1) {f=near[kk]; near[kk]=&schw[ii]; near[6-1]=f; sort(near);break;}
	    else {near[6-1]=&schw[ii];break;}
	  }
	}
	}
      }
      // *
     
      ac=ac*0;
      flag1=false;
      nf=true;


      if ((((ACTUAL_MINDIS+1)<ACTUAL_POS[0] && ACTUAL_POS[0] < (length-1.3)) && ((ACTUAL_MINDIS+1)<ACTUAL_POS[1] && ACTUAL_POS[1] < (height-1.3))) && ((ACTUAL_MINDIS+1)<ACTUAL_POS[2] && ACTUAL_POS[2] < (depth-1.3))){
	flag1=true;
      }
      
      if (flag1==true){

	if (oa.size()!=0)dodge_obstaclea();
	if (ob.size()!=0)dodge_obstacleb();
 
	if(nf==true){ 
	  a=a*0;
	  for (int kk=0;kk<count;kk++){
	    a=a+(*circle[kk]).velocity();
	  }
	  ac=ac+a; //Geschwindigkeit wird der Gruppe angepasst
	}
	fischinteraction();
      }

      else {
	dodge_wand();
	fischinteraction();
      }
      
      if (ac.betrag() > ACTUAL_MAXAC){ac.norm(); ac = ac * ACTUAL_MAXAC;}
      ACTUAL_VEL = schw[jj].velocity() + ac*step;
      if (ACTUAL_VEL.betrag() > ACTUAL_MAXV){ACTUAL_VEL.norm(); ACTUAL_VEL = ACTUAL_VEL * ACTUAL_MAXV;}
      schw[jj].newvel(ACTUAL_VEL);
    }

  for (int jj=0; jj<n;++jj){ 
    ACTUAL_POS = schw[jj].position() + schw[jj].velocity()*step;
    schw[jj].newpos(ACTUAL_POS);
  }

  if (aa%10==0){for (int jj=0; jj<n;++jj) raus<<schw[jj].position()[0]<<"\n"<<schw[jj].position()[1]<<"\n"<<schw[jj].position()[2]<<"\n"<<schw[jj].velocity()[0]<<"\n"<<schw[jj].velocity()[1]<<"\n"<<schw[jj].velocity()[2]<<"\n";}
  }
  raus.close();
};

int main(){
  simulation s(30,30000);
  s.simstart();
}
